//  ** Revision History **
//  15-Mar-1993 (AH) release 1.0.000
//  14-Oct-1992 (AH) ColorBox added.
//  29-Aug-1992 (AH) loading/unload of default bitmap now in LibMain/Wep
//  28-Aug-1992 (AH) picture background allways deleted
//  28-Aug-1992 (AH) Loading the backgriund resource moved to Check Property
//  16-Aug-1992 (EuroSource-AH) Beginning of history

//****************************************************************************
//                    Copyright (C) 1992-1995 EuroSource AB
//
// FILE:         rotary.c  (part of EuroCtrl project)
//   
// PURPOSE:      Make a Rotary Control
//   
// COMMENTS:     Originally from Microsoft Sample rotary by NigelT.
//   
// HISTORY:      920817AH Prehistory
//   
//****************************************************************************                    

#define  NOCOMM
#include <windows.h>
#include <vbapi.h>
#include "esrotary.h"

#include "version.h"
//#include <string.h>
#include <math.h>

#define  CTL_DATA       // To declare static data in rotary.h
#include "rotary.h"
#include "vb1.h"		// Support for Visual Basic 1.0
#include "vb2.h"		// Support for Visual Basic 2.0
#include "helpid.h"

//---------------------------------------------------------------------------
// Global Variables
//---------------------------------------------------------------------------
BOOL    bCaptured;              // TRUE if mouse captured
extern  HANDLE hmodDLL;
extern  WORD ipropDialog;
extern  HCTL hctlDialog;     
extern  HBITMAP gRotaryBackGround;
extern  UINT VBVersion;
//---------------------------------------------------------------------------
// Local Prototypes
//---------------------------------------------------------------------------
VOID NEAR DrawRotary(HCTL hctl, HWND hWnd, HDC hDC);
void CalcPoint(WORD Min, WORD Max, WORD Value, int iXcenter, int iYcenter, int iRad, LPPOINT lpPt);
WORD CalcPos(WORD Min, WORD Max, int iXcenter, int iYcenter, int iXmouse, int iYmouse);

//**************************************************************************
//                        Copyright (C) 1992-1995 EuroSource AB
//
//      FUNCTION:   LONG FAR PASCAL _export RotaryCtlProc(HCTL hctl, HWND hwnd, USHORT msg, USHORT wp, LONG lp)       
//
//      PURPOSE:    Rotary Control Procedure     
//
//      COMMENTS:        
//
//      HISTORY:    920817AH Prehistory     
//
//**************************************************************************

LONG FAR PASCAL _export RotaryCtlProc(HCTL hctl, HWND hWnd, USHORT msg, USHORT wp, LONG lp)
{
    LONG        lResult; 
    WORD                w, xc, yc;
    RECT                rcWnd;
    PROTARY     protary;

    // Message pre-processing
    switch (msg) 
    {
	case WM_CREATE: 
	    protary = ROTARYDEREF(hctl);
	    protary->Min = 0;
	    protary->Max = 255;
	    protary->Value = 128;                                
	    protary->MarkSize = 5;
	    protary->MarkOutlineColor = BLACK;
	    protary->MarkFillColor = RED;
	    protary->Radius=15;
	    
	    // load the standard background bitmap
	    protary->hBmpBkGnd = gRotaryBackGround;   

#ifndef RUNTIMEVERSION	    
	    // set the property text for the About dialog
	    SetAboutText(hctl, IPROP_ROTARY_ABOUT);
#endif
        		    
	    VBSetControlProperty(hctl, IPROP_ROTARY_BACKCOLOR, 
				       ROTARY_BACKGROUND_DEFAULT);
		break;

#ifndef RUNTIMEVERSION		
	case VBM_INITPROPPOPUP:
		switch (wp) 
        {
	    	case IPROP_ROTARY_ABOUT:
				hctlDialog  = hctl;
				ipropDialog = wp;
				return (LONG)HwndInitAboutPopup();
	
			case IPROP_ROTARY_MARKOUTLINECOLOR:
			case IPROP_ROTARY_MARKFILLCOLOR:
	    		if (VBVersion < 0x0200) 
            	{
					hctlDialog  = hctl;
					ipropDialog = wp;
					return (LONG)HwndInitColorPopup();
				}
		}
	break; 
#endif
    	
	case WM_ERASEBKGND:
	    // Don't bother with erasing the background
	    return TRUE;

	case WM_SIZE:
	    break;

    case VBM_GETDEFSIZE:
        return MAKELONG(ROTARY_DEFAULTWIDTH,ROTARY_DEFAULTHEIGHT);    
    	
	case WM_LBUTTONDOWN:
		if (!bCaptured) {
		SetCapture(hWnd);
		bCaptured = TRUE;
		}   
	
	// fall through

	case WM_MOUSEMOVE:
	    protary = ROTARYDEREF(hctl);
		if (bCaptured) {
		// get the coords of the center of the control
		GetClientRect(hWnd, &rcWnd);
		xc = (rcWnd.left + rcWnd.right) / 2;
		yc = (rcWnd.top + rcWnd.bottom) / 2;
		w = CalcPos(protary->Min,
			protary->Max,
			xc,
			yc,
			LOWORD(lp),
			HIWORD(lp));
			protary->Value = w;
		VBFireEvent(hctl, EVENT_ROTARY_CHANGE, NULL);
			InvalidateRect(hWnd, NULL, TRUE);
		}
		break;

#ifndef RUNTIMEVERSION     		   
	case WM_RBUTTONDBLCLK: 
	    if (VBGetMode() == MODE_DESIGN) {
		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, esrotary);
		return OK;
	    }
	    else
		break;
#endif
    	
	case WM_LBUTTONUP:
	    protary = ROTARYDEREF(hctl);
		if (bCaptured) {
		ReleaseCapture();
			bCaptured = FALSE;
		}
		break;
	     
	case WM_PAINT:
	    if (wp)
		DrawRotary(hctl, hWnd, (HDC)(wp));
	    else {
		PAINTSTRUCT     ps;

		BeginPaint(hWnd, &ps);
		DrawRotary(hctl, hWnd, ps.hdc);
		EndPaint(hWnd, &ps);
	    }
	    break;

#ifndef RUNTIMEVERSION    
	case VBM_HELP:
	    switch (LOBYTE(wp))
		{
			case VBHELP_PROP:
		    	// High byte identifies which property.
		    	// Keyword is: "<property>"
		    	switch (HIBYTE(wp))
				{
					case IPROP_ROTARY_ABOUT:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_about);
			    		return OK;

					case IPROP_ROTARY_MARKFILLCOLOR:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_markfillcolor);
			    		return 0L;                                                        
                
                	case IPROP_ROTARY_MARKOUTLINECOLOR:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_markoutlinecolor);
			    		return 0L; 
            	
                	case IPROP_ROTARY_MARKSIZE:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_marksize);
			    		return 0L;                                            
            
            		case IPROP_ROTARY_MARKSTYLE:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_markstyle);
			    		return 0L;                                            
            
            		case IPROP_ROTARY_MAX:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_max);
			    		return 0L;                                            
            
            		case IPROP_ROTARY_MIN:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_min);
			    		return 0L;                                            
            
            		case IPROP_ROTARY_PICTUREBG:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_picturebackground);
			    		return 0L;                                            
            
            		case IPROP_ROTARY_RADIUS:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_radius);
			    		return 0L;                                       
				}
				break;

		case VBHELP_CTL:
		    // High byte is unused.
		    // Keyword is: "<classname>"
		    WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, esrotary);;
		    return 0L;
	}
	break;                  
#endif
        	
	case VBM_SETPROPERTY:
	    switch(wp) {
		case IPROP_ROTARY_VALUE:
		case IPROP_ROTARY_MARKSIZE:
		case IPROP_ROTARY_MARKOUTLINECOLOR:        
		case IPROP_ROTARY_MARKFILLCOLOR:    
		case IPROP_ROTARY_RADIUS:
		case IPROP_ROTARY_MARKSTYLE:        
		    InvalidateRect(hWnd, NULL, TRUE);
		    break;
		}
		break;
	    
	case VBM_CHECKPROPERTY:
	    switch (wp) {
		case IPROP_ROTARY_MIN:  
		    protary = ROTARYDEREF(hctl);
			if (protary->Min < protary->Value)
			return ERR_None;
		    else
			return ERR_InvPropVal;
		    break;
		    
		case IPROP_ROTARY_MAX:
		    protary = ROTARYDEREF(hctl);
			if (protary->Max > protary->Value)
			return ERR_None;
		    else
			return ERR_InvPropVal;
		    break;
		
		case IPROP_ROTARY_LABEL:    
		    break;          
		
		case IPROP_ROTARY_PICTUREBG: {
		    PIC pic;

			VBGetPic((HPIC)lp, &pic);
		    protary = ROTARYDEREF(hctl);
		    
			switch (pic.picType) {
				case PICTYPE_NONE:  
			    protary->hBmpBkGnd = gRotaryBackGround;
			    InvalidateRect(hWnd, NULL, TRUE);
				return ERR_None;
			
				case PICTYPE_BITMAP:  
				protary->hBmpBkGnd = pic.picData.bmp.hbitmap;
				InvalidateRect(hWnd, NULL, TRUE);
				return ERR_None;
			}
			return ERR_InvPropVal;
		} 
		break;    
	    }
	    break;
    }

    // Default processing:
    lResult = VBDefControlProc(hctl, hWnd, msg, wp, lp);

    // Message post-processing:
    switch (msg) {
	case WM_DESTROY: {
	    
	    protary = ROTARYDEREF(hctl);
	    VBFreePic(protary->hPicBkGnd);
		break;
	}    
    }
    return lResult;
}


//**************************************************************************
//                      Copyright (C) 1992-1995 EuroSource AB
//
//      FUNCTION:   VOID NEAR DrawRotary(HCTL hctl, HWND hWnd, HDC hDC)       
//
//      PURPOSE:    Draw the Rotary     
//
//      COMMENTS:   Originally from Microsoft sample rotary     
//
//      HISTORY:    920817AH Prehistory     
//
//**************************************************************************

VOID NEAR DrawRotary(HCTL hctl, HWND hWnd, HDC hDC)
{
    PROTARY protary = ROTARYDEREF(hctl);
    RECT        rcClient;
    HBRUSH      hbr;
    HBITMAP hbmOld, hbmOff, hbmOldOff;
    BITMAP      bmp;
    HDC         hdcMem, hdcOff;
    HPEN        hpenOld, hpenDot, hpenDotw;
    HBRUSH      hbrOld, hbrDot;
    POINT       pt,ptarrow[4];
    int         x, y, marksize;  
			  
    marksize = protary->MarkSize;
		    
    hbr = (HBRUSH)SendMessage(GetParent(hWnd), WM_CTLCOLOR, hDC, MAKELONG(hWnd, 0));
    
    // get the size of the bitmap so we can center it
    GetObject(protary->hBmpBkGnd, sizeof(BITMAP), (LPSTR)&bmp);
    
    // get the window size
    GetClientRect(hWnd, &rcClient);
    
    x = (rcClient.right - rcClient.left - bmp.bmWidth) / 2 + rcClient.left;
    y = (rcClient.bottom - rcClient.top - bmp.bmHeight) / 2 + rcClient.top;

    // create an off screen dc and a bitmap big enough
    hdcOff = CreateCompatibleDC(hDC);
    hbmOff = CreateCompatibleBitmap(hDC, 
				    rcClient.right-rcClient.left,
				    rcClient.bottom-rcClient.top);
    hbmOldOff = SelectObject(hdcOff, hbmOff);

    // blit the background image to the offscreen dc
    hdcMem = CreateCompatibleDC(hDC);
    FillRect(hdcOff, &rcClient, hbr);
    
    hbmOld = SelectObject(hdcMem, protary->hBmpBkGnd);

    BitBlt(hdcOff,
	   x,
	   y,
	   rcClient.right-rcClient.left,
	   rcClient.bottom-rcClient.top,
	   hdcMem,
	   0, 0, 
	   SRCCOPY);

    SelectObject(hdcMem, hbmOld);
    DeleteDC(hdcMem);

    // Draw the control value at the bottom
    //wsprintf(text, "%d %s", protary->Value, (LPSTR)VBDerefHsz(protary->Label));
    //SetBkMode(hdcOff, TRANSPARENT);
    //SetTextColor(hdcOff, BLUE);
    //DrawText(hdcOff, text, -1, &rcClient, DT_SINGLELINE | DT_BOTTOM | DT_CENTER);

    // compute the angle of the dot
    CalcPoint(  protary->Min, 
		protary->Max, 
		protary->Value,
		(rcClient.left + rcClient.right) / 2,
		(rcClient.top + rcClient.bottom) / 2,
		protary->Radius, 
		&pt);
    
    // Draw the Dot/Line/Triangle
    hpenDot = CreatePen(PS_SOLID, 1, RGBCOLOR(protary->MarkOutlineColor));
    hpenDotw = CreatePen(PS_SOLID, 2, RGBCOLOR(protary->MarkOutlineColor));
    hbrDot = CreateSolidBrush(RGBCOLOR(protary->MarkFillColor));
    hpenOld = SelectObject(hdcOff, hpenDot);
    hbrOld = SelectObject(hdcOff, hbrDot);                   
    //SetROP2(hdcOff, R2_MERGEPEN);  
    switch(protary->MarkStyle) {
	case TOOLMARKSTYLEDOT:
		Ellipse(hdcOff, pt.x - marksize, pt.y - marksize, pt.x + marksize, pt.y + marksize);
		break;
	
	case TOOLMARKSTYLELINE: 
	    SelectObject(hdcOff, hpenDotw);
		MoveTo(hdcOff, pt.x, pt.y);
		// compute the angle of the inner dot
		CalcPoint(  protary->Min, 
		protary->Max, 
		protary->Value,
		(rcClient.left + rcClient.right) / 2,
		(rcClient.top + rcClient.bottom) / 2,
		protary->Radius-marksize, 
		&pt);
		LineTo(hdcOff, pt.x, pt.y);       
	    break;
	
	case TOOLMARKSTYLEBOX: 
	    Rectangle(hdcOff,   pt.x-(marksize/2),
						pt.y-(marksize/2),
						pt.x+(marksize/2),
						pt.y+(marksize/2));       
	    break;
	
	case TOOLMARKSTYLEARROW:
	    // compute the angle of the left lower dot of the arrow
		CalcPoint(  protary->Min, 
		protary->Max, 
		protary->Value-20,
		(rcClient.left + rcClient.right) / 2,
		(rcClient.top + rcClient.bottom) / 2,
		protary->Radius-marksize, 
		&ptarrow[1]);         
	    
	    // compute the angle of the right lower dot of the arrow
		CalcPoint(  protary->Min, 
		protary->Max, 
		protary->Value+20,
		(rcClient.left + rcClient.right) / 2,
		(rcClient.top + rcClient.bottom) / 2,
		protary->Radius-marksize, 
		&ptarrow[2]); 
	    ptarrow[0].x = pt.x;
	    ptarrow[0].y = pt.y;
	    ptarrow[3].x = pt.x;
	    ptarrow[3].y = pt.y;
	    Polygon(hdcOff, ptarrow, 4);
	    break;
    }
    SelectObject(hdcOff, hpenOld);
    SelectObject(hdcOff, hbrOld);
    DeleteObject(hpenDot);
    DeleteObject(hpenDotw);
    DeleteObject(hbrDot);

    // blit the offscreen dc stuff to the screen dc
    BitBlt(hDC,
	   rcClient.left,
	   rcClient.top,
	   rcClient.right-rcClient.left,
	   rcClient.bottom-rcClient.top,
	   hdcOff,
	   0, 0, 
	   SRCCOPY);

    // tidy up the off screen stuff
    SelectObject(hdcOff, hbmOldOff);
    DeleteObject(hbmOff);
    DeleteDC(hdcOff);
}     

//****************************************************************************
//                    Copyright (C) 1992-1995 EuroSource AB
//
// FUNCTION:    WORD CalcPos(WORD Min, WORD Max, int iXcenter, int iYcenter, int iXmouse, int iYmouse)
//
// PURPOSE:     
//
// COMMENTS:    Originally from Microsoft sample rotary.
//
// HISTORY:             17-Aug-1992 Mon 00:07:34 AH  PREHISTORY
//
//****************************************************************************

WORD CalcPos(WORD Min, WORD Max, int iXcenter, int iYcenter, int iXmouse, int iYmouse) 
{
    int dx, dy;
    WORD Value;
    double a, min, max;

    // compute the x and y offsets
    dx = iXmouse - iXcenter;
    dy = iYmouse - iYcenter;

    // check for stupid case
    if ((dx == 0) && (dy == 0)) {
	dx = 1;
	dy = 1; // force a position that works
    }

    // get the angle in degrees
    a = (57.3 * atan2((double)dy, (double)dx));        
    if ((a > 45.0) && (a <= 90.)) {
	a = 45.0;
    } else if ((a > 90.0) && (a < 135.0)) {
	a = 135.0;
    }

    a -= 135.0;
    if (a < 0.0) a += 360.0;

    // compute the control value
    min = (double) Min;
    max = (double) Max;
    Value = (WORD) (min + ((max - min) * a / 270.0));

    return Value;
}

//****************************************************************************
//                         Copyright (C) 1992-1995 EuroSource AB
//
// FUNCTION:    void CalcPoint(WORD Min, WORD Max, WORD Value, int iXcenter, int iYcenter, int iRad, LPPOINT lpPt)
//
// PURPOSE:     
//
// COMMENTS:    Originally from Microsoft sample rotary
//
// HISTORY:             17-Aug-1992 Mon 00:03:27 AH  PREHISTORY
//
//****************************************************************************


void CalcPoint(WORD Min, WORD Max, WORD Value, int iXcenter, int iYcenter, int iRad, LPPOINT lpPt)  
{
    double a;  

    a = 2.36 + 4.71 * (double)(Value - Min) / (double)(Max - Min);

    lpPt->x = iXcenter + (int) ((double)iRad * cos(a));
    lpPt->y = iYcenter + (int) ((double)iRad * sin(a));

} 
				  
