//****************************************************************************
//                    Copyright (C) 1992-1995 EuroSource AB
//
// FILE:         rotary.h
//   
// PURPOSE:      Header file for ROTARY subclass EuroCtrl project
//   
// COMMENTS:     
//   
// HISTORY:      920817AH Prehistory
//   
//****************************************************************************                    



#define ROTARY_BACKGROUND_DEFAULT    GREY

#define ROTARY_DEFAULTWIDTH		30
#define ROTARY_DEFAULTHEIGHT    30 
//---------------------------------------------------------------------------
// ROTARY control data and structs
//---------------------------------------------------------------------------
typedef struct tagROTARY
{                     
    HSZ     hszabout;
	SHORT   Min;            // minimum value
	SHORT   Max;            // maximum value
	SHORT   Value;          // current value
	HSZ     Label;      	// label for units
	HBITMAP hBmpBkGnd;      // handel to std BMP picture for background
    HPIC    hPicBkGnd;  	// handle to user BMP picture for background
	PIC     BmpBG;          // picture for background
	SHORT   MarkSize;       // Size in pixels for marker
	LONG    MarkOutlineColor;       // Color for marker border
	LONG    MarkFillColor;  // Color for marker interior
	SHORT   Radius;         // distance from center to marker
	ENUM    MarkStyle;      // style for mark
} ROTARY;

typedef ROTARY FAR * PROTARY;

#define ROTARYDEREF(hctl)     ((PROTARY)VBDerefControl(hctl))


//---------------------------------------------------------------------------
// Control Procedure
//---------------------------------------------------------------------------
LONG FAR PASCAL _export RotaryCtlProc(HCTL, HWND, USHORT, USHORT, LONG);


#ifndef RC_INVOKED
//---------------------------------------------------------------------------
// Property list
//---------------------------------------------------------------------------
// Define the consecutive indicies for the properties
//---------------------------------------------------------------------------
#define IPROP_ROTARY_NAME           0
#define IPROP_ROTARY_INDEX          	1
#define IPROP_ROTARY_PARENT         	2
#define IPROP_ROTARY_BACKCOLOR      	3
#define IPROP_ROTARY_LEFT           	4
#define IPROP_ROTARY_TOP            	5
#define IPROP_ROTARY_WIDTH          	6
#define IPROP_ROTARY_HEIGHT         	7
#define IPROP_ROTARY_ENABLED        	8
#define IPROP_ROTARY_VISIBLE        	9
#define IPROP_ROTARY_MOUSEPOINTER   	10
#define IPROP_ROTARY_BORDER             11
#define IPROP_ROTARY_FORECOLOR          12 
#define IPROP_ROTARY_ABOUT              13
#define IPROP_ROTARY_MIN                14
#define IPROP_ROTARY_MAX                15
#define IPROP_ROTARY_VALUE              16
#define IPROP_ROTARY_PICTUREBG          17
#define IPROP_ROTARY_LABEL              18
#define IPROP_ROTARY_MARKSIZE           19
#define IPROP_ROTARY_MARKOUTLINECOLOR   20
#define IPROP_ROTARY_MARKFILLCOLOR      21
#define IPROP_ROTARY_RADIUS             22
#define IPROP_ROTARY_MARKSTYLE          23
#define IPROP_ROTARY_HWND				24

#ifdef CTL_DATA                       

PROPINFO Property_Rotary_About =
{
    "About...",
    DT_HSZ | PF_fGetData | PF_fSetData | PF_fEditable,
    OFFSETIN(ROTARY, hszabout)
}; 

PROPINFO Property_Rotary_Min =
{
    "Min",
    DT_SHORT | PF_fGetData | PF_fSetCheck | PF_fSetData | PF_fSaveData,
    OFFSETIN(ROTARY, Min)
}; 
					
PROPINFO Property_Rotary_Max =
{
    "Max",
    DT_SHORT | PF_fGetData | PF_fSetCheck | PF_fSetData | PF_fSaveData,
    OFFSETIN(ROTARY, Max)
};
			
PROPINFO Property_Rotary_Value =
{
    "Value",
    DT_SHORT | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData,
    OFFSETIN(ROTARY, Value)
};  

PROPINFO Property_Rotary_Picture =
{
    "PictureBackGround",
    DT_PICTURE | PF_fGetData | PF_fSetCheck | PF_fSetData | PF_fSaveData,
    OFFSETIN(ROTARY, hPicBkGnd)
};
			      
PROPINFO Property_Rotary_Label =
{
    "Label",
    DT_HSZ | PF_fGetData | PF_fSetCheck | PF_fSetData | PF_fSaveData,
    OFFSETIN(ROTARY, Label)
};

PROPINFO Property_Rotary_MarkSize =
{
    "MarkSize",
    DT_SHORT | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData,
    OFFSETIN(ROTARY, MarkSize)
};                           

PROPINFO Property_Rotary_MarkOutlineColor =
{
    "MarkOutlineColor",
    DT_COLOR | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fEditable,
    OFFSETIN(ROTARY, MarkOutlineColor)
};                                  

PROPINFO Property_Rotary_MarkFillColor =
{
    "MarkFillColor",
    DT_COLOR | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fEditable,
    OFFSETIN(ROTARY, MarkFillColor)
}; 

PROPINFO Property_Rotary_Radius=
{
    "Radius",
    DT_SHORT | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData,
    OFFSETIN(ROTARY, Radius)
};
		     
#define TOOLMARKSTYLELINE       0
#define TOOLMARKSTYLEDOT        1
#define TOOLMARKSTYLEBOX        2
#define TOOLMARKSTYLEARROW      3

PROPINFO Property_Rotary_MarkStyle=
{
    "MarkStyle",
    DT_ENUM | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData,
    OFFSETIN(ROTARY, MarkStyle), 0,
	0,
	"0 - Line.\0"
	"1 - Dot.\0"
	"2 - Box.\0",
	TOOLMARKSTYLEBOX
}; 

PROPINFO Property_Rotary_hWnd =
{
    "hWnd",
    DT_SHORT | PF_fGetMsg | PF_fNoShow | PF_fNoRuntimeW,
    0, 0
};     

PPROPINFO proplistRotary[] =
{
    PPROPINFO_STD_CTLNAME,
    PPROPINFO_STD_INDEX,
    PPROPINFO_STD_PARENT,
    PPROPINFO_STD_BACKCOLOR,
    PPROPINFO_STD_LEFT,
    PPROPINFO_STD_TOP,
    PPROPINFO_STD_WIDTH,
    PPROPINFO_STD_HEIGHT,
    PPROPINFO_STD_ENABLED,
    PPROPINFO_STD_VISIBLE,
    PPROPINFO_STD_MOUSEPOINTER,
    PPROPINFO_STD_BORDERSTYLEOFF,
    PPROPINFO_STD_FORECOLOR,
    &Property_Rotary_About,            
    &Property_Rotary_Min,
    &Property_Rotary_Max,
    &Property_Rotary_Value,
    &Property_Rotary_Picture,
    &Property_Rotary_Label,
    &Property_Rotary_MarkSize,
    &Property_Rotary_MarkOutlineColor,
    &Property_Rotary_MarkFillColor,
    &Property_Rotary_Radius, 
    &Property_Rotary_MarkStyle,
    &Property_Rotary_hWnd,
    NULL
};     
#endif  // CTL_DATA 

//---------------------------------------------------------------------------
// Event list
//---------------------------------------------------------------------------
// Define the consecutive indicies for the events
//---------------------------------------------------------------------------
EVENTINFO Event_Change_Rotary =
{
    "Change",
    0,
    0,
    NULL,
    NULL
}; 

#define EVENT_ROTARY_CHANGE     0
#define EVENT_ROTARY_DRAGDROP   1
#define EVENT_ROTARY_DRAGOVER   2

#ifdef CTL_DATA
PEVENTINFO eventlistRotary[] =
{                                
    &Event_Change_Rotary,
    PEVENTINFO_STD_DRAGDROP,
    PEVENTINFO_STD_DRAGOVER,
    NULL
};
#endif  // CTL_DATA


//---------------------------------------------------------------------------
// Model struct
//---------------------------------------------------------------------------
// Define the control model (using the event and property structures).
//---------------------------------------------------------------------------
#ifdef CTL_DATA
MODEL modelRotary =
{
    VB_VERSION,                 // VB version being used
    MODEL_fDesInteract | MODEL_fFocusOk,                // MODEL flags
    (PCTLPROC)RotaryCtlProc,    // Control procedure
    CS_VREDRAW | CS_HREDRAW,    // Class style
    NULL,                               // Default Window style
    sizeof(ROTARY),             // cbCtlExtra for ROTARY structure
    IDBMP_ROTARY,               // Palette bitmap ID
    "EsRotary",                         // Default control name
    "EsRotary",                         // Visual Basic class name
    NULL,                       // Parent class name
    proplistRotary,             // Properties list
    eventlistRotary,            // Events list
	IPROP_ROTARY_VALUE,			// default property in code window : Value
	EVENT_ROTARY_CHANGE,		// default event in code window
	IPROP_ROTARY_VALUE			// standard property
};
#endif  // CTL_DATA
    
LPMODEL modellistRotary[] =
    {
    &modelRotary,
    NULL
    };

MODELINFO modelinfoRotary =
    {
    VB_VERSION, 			// VB version being used
    modellistRotary			// MODEL list
    };
    
#endif  // RC_INVOKED

// misc defines for Rotary

// ROP Codes
#define DSa     0x008800C6L
#define DSx     0x00660046L

// resource ids

#define IDR_CONTROL     200

// control window dimensions

#define ROTARY_WIDTH    100     // rotary control width
#define ROTARY_HEIGHT   100     // rotary control height

// define the control range

#define MIN_UNITS       1
#define MAX_UNITS       11

// private data structure for each rotary window instance

typedef struct _RINFO {
    WORD wMin;              // minimum control value
    WORD wMax;              // maximum control value
    WORD wPos;              // current control value
    HBITMAP hbmBkGnd;       // background bitmap image
    char szUnits[16];       // label for units (e.g. Hz, WPM ...)
} RINFO, *NPRINFO;

// macros to talk to rotary controls

#define rcSetMin(hWnd, w) SendMessage(hWnd, RC_SETMIN, w, NULL)
#define rcSetMax(hWnd, w) SendMessage(hWnd, RC_SETMAX, w, NULL)
#define rcSetPos(hWnd, w) SendMessage(hWnd, RC_SETPOS, w, NULL)
#define rcGetPos(hWnd) SendMessage(hWnd, RC_GETPOS, NULL, NULL)
#define rcSetUnits(hWnd,szUnits) SendMessage(hWnd, RC_SETUNITS, 0, (LONG)(LPSTR)(szUnits))

 
